Attribute VB_Name = "modToolTip"
'====================================================================================================
'Nom du programme : DKS_ToolTip
'Version : 1.0.0
'Auteurs : Nicolas Teillet
'Environnement de dveloppement : Visual basic 6.0
'Rsum : objet permettant d'attribuer une tooltip personnalisable  un contrle
'====================================================================================================
'====================================================================================================
'Nom du fichier : modToolTip.bas
'Cre le        : 30/12/2004
'Rle           : Module permettant d'appliquer automatiquement les tooltips aux contrles
'====================================================================================================

'dclaration des variables prives
Dim oToolTip() As CDKSToolTip 'stocke l'objet de tooltip temporairement

Public Sub ApplyToolTip(ByRef frmForm As Form)

'======================================================================
'Sub : ApplyToolTip
'Date : 03/01/2005
'Auteur : DarK Sidious
'But : Permet d'appliquer les tooltips avances  tout les contrles d'une feuille
'======================================================================

'on active la routine de traitement d'erreur
'On Error Resume Next
'l'erreur etant minime, on continue l'xcution normalement

'dclaration des variables prives
Dim oFor1 As Object 'stocke les valeurs de la boucle For->Each
Dim sToolTipText As String 'stocke le texte du tooltip
Dim sInfo As String 'stocke l'information rcupre
Dim iNombreControles As Integer 'stocke le nombre de contrle ncessitant un tooltip dans la feuille
Dim iPosition As Integer 'stocke la position de la recherche

    'on parcours tout les contrles de la feuille et on compte le nombre de contrle ncessitant un tooltip
    ''For Each oFor1 In frmForm.Controls

        ''Let sToolTipText = oFor1.ToolTipText
        Let sToolTipText = frmForm.Picture2.ToolTipText
  
        If sToolTipText <> "" Then
        
            'on teste si on veux un tooltip avanc ou pas
            If InStr(1, sToolTipText, "[") > 0 Then
            
                Let iNombreControles = iNombreControles + 1
            
            End If
        
        End If
    
    'Next oFor1

    'on redimensionne le tableau des contrles
    ReDim oToolTip(iNombreControles)
    Let iNombreControles = 0

    'on parcours tout les contrles de la feuille et on compte le nombre de contrle ncessitant un tooltip
    'For Each oFor1 In frmForm.Controls
    Set oFor1 = frmForm.Picture2
        Let sToolTipText = oFor1.ToolTipText

        If sToolTipText <> "" Then
        
            'on teste si on veux un tooltip avanc ou pas
            If InStr(1, sToolTipText, "[") > 0 Then
                
                'on cre un nouveau objet de tooltip
                Set oToolTip(iNombreControles) = New CDKSToolTip
            
                'on rcupre les informations
                Let sInfo = Balise(sToolTipText, "Title=")
                If sInfo <> "" Then Let oToolTip(iNombreControles).Title = sInfo
                Let sInfo = Balise(sToolTipText, "TipText=")
                
                'on remplace les vbcrlf par des vrais sauts de ligne
                Let iPosition = 1
                While (iPosition > 0)
                
                    Let iPosition = InStr(iPosition + 1, sInfo, "vbcrlf")
                    If iPosition > 1 Then
                    
                        Let sInfo = Left(sInfo, iPosition - 1) & vbCrLf & Right(sInfo, Len(sInfo) - Len("vbcrlf") - iPosition)
                    
                    End If
                    
                Wend
                If sInfo <> "" Then Let oToolTip(iNombreControles).TipText = sInfo
                
                Let sInfo = Balise(sToolTipText, "BackColor=")
                If sInfo <> "" Then Let oToolTip(iNombreControles).BackColor = CLng(sInfo)
                Let sInfo = Balise(sToolTipText, "DisplayTime=")
                If sInfo <> "" Then Let oToolTip(iNombreControles).DisplayTime = CLng(sInfo)
                Let sInfo = Balise(sToolTipText, "ForeColor=")
                If sInfo <> "" Then Let oToolTip(iNombreControles).ForeColor = CLng(sInfo)
                Let sInfo = Balise(sToolTipText, "IconStyle=")
                If sInfo <> "" Then Let oToolTip(iNombreControles).IconStyle = CInt(sInfo)
                Let sInfo = Balise(sToolTipText, "IsCentered=")
                If sInfo <> "" Then Let oToolTip(iNombreControles).IsCentered = CBool(sInfo)
                Let sInfo = Balise(sToolTipText, "Style=")
                If sInfo <> "" Then Let oToolTip(iNombreControles).Style = CInt(sInfo)
                Let sInfo = Balise(sToolTipText, "TransparenceFactor=")
                If sInfo <> "" Then Let oToolTip(iNombreControles).TransparenceFactor = CByte(sInfo)
                Let sInfo = Balise(sToolTipText, "WaitTime=")
                If sInfo <> "" Then Let oToolTip(iNombreControles).WaitTime = CLng(sInfo)
                Call oToolTip(iNombreControles).CreateToolTip(oFor1.hwnd)
                Let oFor1.ToolTipText = ""

                'on incrmente l'index dans le tableau
                Let iNombreControles = iNombreControles + 1
                
            End If
        
        End If
    
    'Next oFor1

End Sub

Private Function Balise(ByVal sTexte, ByVal sBalise) As String

'======================================================================
'Function : Balise
'Date : 03/01/2005
'Auteur : DarK Sidious
'But : Permet de rcuprer le texte associ  une balise
'======================================================================

'on active la routine de traitement d'erreur
'On Error GoTo erreur0

'dclaration des variables prives
Dim lPosition(1) As Long 'stocke les positions dans le texte lors des recherches

    'on cherche la balise dans le texte
    Let lPosition(0) = InStr(1, sTexte, "[" & sBalise)
    If lPosition(0) < 1 Then
    
        'la balise n'a pas t trouve
        Let Balise = ""
        Exit Function
        
    End If
    Let lPosition(1) = InStr(lPosition(0), sTexte, "]")
    If lPosition(1) < 1 Then
    
        'la balise n'a pas t trouve
        Let Balise = ""
        Exit Function
        
    End If
    
    'on renvoie le texte de la balise
    Let Balise = Mid(sTexte, lPosition(0) + Len(sBalise) + 1, lPosition(1) - (lPosition(0) + Len(sBalise) + 1))

'la fonction est finie
Exit Function

'routine de traitement d'erreur
erreur0:
'Problme : On n'a pas pu rcuprer le texte de la balise
'Solution : On renvoie une chane vide
Let Balise = ""

End Function
